<?php
/**
 * wp-smtp-contact-form is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
require_once(plugin_dir_path(__FILE__).'Mail.php');
require_once(plugin_dir_path(__FILE__).'Mail/mime.php');

class MailSender {
    private $header;
    private $mime;
    private $recipients = '';
    private $text;
    private $smtpd;

    public function __construct($from) {
        $this->mime = new Mail_mime();
        $this->header = array('From' => $from, 'Subject' => '');
    }

    public function setText($text) {
        $this->text = $text;
    }

    public function setHost($smtpd) {
        $this->smtpd = $smtpd;
    }

    public function setTo($to) {
        $this->header['To'] = $to;
        $this->recipients = $to;
    }

    public function setSubject($subject) {
        $this->header['Subject'] = $subject;
    }

    public function send() {
        $this->mime->setHTMLBody($this->text);
        $param = array('html_encoding' => 'base64');
        $body = $this->mime->get();
        $hdrs = $this->mime->headers($this->header);
        $params = array('host' => $this->smtpd);
        $mail =& Mail::factory('smtp', $params);
        return $mail->send($this->recipients, $hdrs, $body);
    }
}

function smtp_mail($smtpd, $to, $subject, $fullmsg) {
    $mailSender = new MailSender($to); //to is also from!
    $mailSender->setHost($smtpd);
    $mailSender->setSubject($subject);
    $mailSender->setTo($to);
    $mailSender->setText($fullmsg);
    return $mailSender->send();
}
?>
